#ifndef RALEIGH_W_LABEL_H
#define RALEIGH_W_LABEL_H

#include <raleigh/widget.h>
#include <libfont/fonts.h>

namespace raleigh {
  class label : public widget {
  public:
    //this pointer is used directly, and the contents of the string should not be changed afterward
    label(const char *value, const char *font="fixed-10",
      _pixel_t bg=RGB(bf, bf, bf), _pixel_t fg=RGB(00, 00, 00));

    void notify_window_change() override;
    void paint(_pixel_t *pixbuf, uint32_t pitch) override;
  private:
    const char *const value;
    const struct font_info *const fi;
    const _pixel_t bg;
    const _pixel_t fg;
  };
}

#endif