#include <raleigh/w/label.h>
#include <libfont/fonts.h>
#include <knob/block.h>

namespace raleigh {
  label::label(const char *value, const char *font, _pixel_t bg, _pixel_t fg)
    : value(value), fi(get_font(font)), bg(bg), fg(fg) {
    size = coord(
      fi->space_width * (strlen(value) - 1) + fi->char_width,
      fi->char_height
    );
  }

  void label::notify_window_change() {}

  void label::paint(_pixel_t *pixbuf, uint32_t pitch) {
    for (uint32_t y = window_offset.y; y < window_offset.y + size.y; ++y)
      for (uint32_t x = window_offset.x; x < window_offset.x + size.x; ++x)
        pixbuf[y * pitch + x] = bg;

    _pixel_t *ptr = pixbuf + window_offset.y * pitch + window_offset.x;
    for (const char *c = value; *c; ++c) {
      put_char(fi, *c, ptr, pitch, bg, fg);
      ptr += fi->space_width;
    }
  }
}